Index: trunk/kernel/syscalls/sys_mkfifo.c
===================================================================
--- trunk/kernel/syscalls/sys_mkfifo.c	(revision 690)
+++ trunk/kernel/syscalls/sys_mkfifo.c	(revision 1)
@@ -1,16 +1,15 @@
 /*
- * sys_mkfifo.c - creates a named FIFO file.
+ * kern/sys_mkfifo.c - creates a FIFO named file
+ * 
+ * Copyright (c) 2008,2009,2010,2011,2012 Ghassan Almaless
+ * Copyright (c) 2011,2012 UPMC Sorbonne Universites
  *
- * Author    Alain Greiner (2016,2017,2018,2019,2020)
+ * This file is part of ALMOS-kernel.
  *
- * Copyright (c) UPMC Sorbonne Universites
- *
- * This file is part of ALMOS-MKH.
- *
- * ALMOS-MKH is free software; you can redistribute it and/or modify it
+ * ALMOS-kernel is free software; you can redistribute it and/or modify it
  * under the terms of the GNU General Public License as published by
  * the Free Software Foundation; version 2.0 of the License.
  *
- * ALMOS-MKH is distributed in the hope that it will be useful, but
+ * ALMOS-kernel is distributed in the hope that it will be useful, but
  * WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
@@ -18,123 +17,37 @@
  *
  * You should have received a copy of the GNU General Public License
- * along with ALMOS-MKH; if not, write to the Free Software Foundation,
+ * along with ALMOS-kernel; if not, write to the Free Software Foundation,
  * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
  */
 
-#include <hal_kernel_types.h>
-#include <hal_uspace.h>
-#include <printk.h>
+#include <kdmsg.h>
 #include <vfs.h>
-#include <process.h>
+#include <sys-vfs.h>
+#include <task.h>
 #include <thread.h>
 
-////////////////////////////////////
-int sys_mkfifo ( char    * pathname,
-                 uint32_t  mode )
+int sys_mkfifo (char *pathname, uint_t mode)
 {
-    vseg_t      * vseg;
-    error_t       error;
-    xptr_t        root_inode_xp;           
-    char          kbuf[CONFIG_VFS_MAX_PATH_LENGTH];
+	register error_t err = 0;
+	struct task_s *task = current_task;
+	struct ku_obj ku_path;
 
-    thread_t    * this    = CURRENT_THREAD;
-    process_t   * process = this->process;
+	current_thread->info.errno = ENOSYS;
+	return -1;
 
-#if DEBUG_SYS_MKFIFO || DEBUG_SYSCALLS_ERROR || CONFIG_INSTRUMENTATION_SYSCALLS
-uint64_t     tm_start = hal_get_cycles();
-#endif
+	KU_BUFF(ku_path, pathname);
+	rwlock_rdlock(&task->cwd_lock);
+	if((err = vfs_mkfifo(&task->vfs_cwd, &ku_path, mode)))
+	{
+		printk(INFO, "INFO: sys_mkfifo: Thread %x, CPU %d, Error Code %d\n", 
+		       current_thread, 
+		       cpu_get_id(), 
+		       err);
 
-#if DEBUG_SYS_MKFIFO
-if( DEBUG_SYS_MKFIFO < tm_end )
-printk("\n[%s] thread[%x,%x] enter for <%s> / cycle %d\n",
-__FUNCTION__, process->pid, this->trdid, pathname, (uint32_t)tm_start );
-#endif
- 
-    // check pathname in user space
-    if( vmm_get_vseg( process, (intptr_t)pathname , &vseg ) )
-	{
-
-#if DEBUG_SYSCALLS_ERROR
-if( DEBUG_SYSCALLS_ERROR < (uint32_t)tm_start )
-printk("\n[ERROR] in %s : user buffer unmapped %x for thread[%x,%x]\n",
-__FUNCTION__ , (intptr_t)pathname , process->pid, this->trdid );
-#endif
-		this->errno = EINVAL;
-        return -1;
+		rwlock_unlock(&task->cwd_lock);
+		return -1;
 	}
-
-    // check pathname length
-    if( hal_strlen_from_uspace( pathname ) >= CONFIG_VFS_MAX_PATH_LENGTH )
-    {
-
-#if DEBUG_SYSCALLS_ERROR
-if( DEBUG_SYSCALLS_ERROR < (uint32_t)tm_start )
-printk("\n[ERROR] in %s : pathname too long for thread[%x,%x]\n",
-__FUNCTION__ , process->pid , this->trdid );
-#endif
-        this->errno = ENFILE;
-        return -1;
-    }
-
-    // copy pathname in kernel space
-    hal_strcpy_from_uspace( XPTR( local_cxy , kbuf ),
-                            pathname,
-                            CONFIG_VFS_MAX_PATH_LENGTH );
-
-#if DEBUG_SYS_MKFIFO
-if( DEBUG_SYS_MKFIFO < tm_end )
-printk("\n[%s] thread[%x,%x] enter for <%s> / cycle %d\n",
-__FUNCTION__, process->pid, this->trdid, kbuf, (uint32_t)tm_start );
-#endif
- 
-    // get cluster and local pointer on reference process
-    xptr_t      ref_xp  = process->ref_xp;
-    process_t * ref_ptr = GET_PTR( ref_xp );
-    cxy_t       ref_cxy = GET_CXY( ref_xp );
-
-    // get extended pointer on root inode in path
-    if( kbuf[0] == '/' )                            // absolute path
-    {
-        // use extended pointer on VFS root inode
-        root_inode_xp = process->vfs_root_xp;
-    }
-    else                                            // relative path
-    {
-        // use extended pointer on CWD inode
-        root_inode_xp = hal_remote_l64( XPTR( ref_cxy , &ref_ptr->cwd_xp ) );
-    }
-
-    // call the relevant VFS function
-    error = vfs_mkfifo( root_inode_xp,
-                        kbuf,
-                        mode ); 
-    if( error )
-    {
-
-#if DEBUG_SYSCALLS_ERROR
-if( DEBUG_SYSCALLS_ERROR < (uint32_t)tm_start )
-printk("\n[ERROR] in %s : thread[%x,%x] cannot create node in VFS for <%s> path\n",
-__FUNCTION__ , process->pid , this->trdid , kbuf );
-#endif
-        this->errno = ENFILE;
-        return -1;
-    }
-
-#if (DEBUG_SYS_MKFIFO || CONFIG_INSTRUMENTATION_SYSCALLS)
-uint64_t     tm_end = hal_get_cycles();
-#endif
-
-#if DEBUG_SYS_MKFIFO
-if( DEBUG_SYS_MKFIFO < tm_end )
-printk("\n[%s] thread[%x,%x] exit for <%s> / cycle %d\n",
-__FUNCTION__, process->pid, this->trdid, pathname, (uint32_t)tm_end );
-#endif
- 
-#if CONFIG_INSTRUMENTATION_SYSCALLS
-hal_atomic_add( &syscalls_cumul_cost[SYS_MKFIFO] , tm_end - tm_start );
-hal_atomic_add( &syscalls_occurences[SYS_MKFIFO] , 1 );
-#endif
-
-    return 0;
-
-} // end sys_mkfifo()
+	rwlock_unlock(&task->cwd_lock);
+   
+	return 0;
+}
